/*
 * ComputationThread.java
 *
 * Created on November 20, 2003, 12:52 PM
 */

package edu.umiacs.fmm.gui;
import edu.umiacs.fmm.*;
/**
 *
 * @author  wpwy
 */
public class ComputationThread extends Thread {
    private FmmTree fmmTree = null;
    private double error = 0;
    private long opsDirect = 0;
    private long opsIndirect =0;
    //AnimationThread animt;
    
    /**
     * Utility field used by event firing mechanism.
     */
    private javax.swing.event.EventListenerList listenerList =  null;
    
    /**
     * Utility field used by bound properties.
     */
    private java.beans.PropertyChangeSupport propertyChangeSupport =  new java.beans.PropertyChangeSupport(this);
    
    /**
     * Holds value of property u.
     */
    private double[] u = null;
    /** Creates a new instance of ComputationThread */
    public ComputationThread() {
    }
    public ComputationThread(FmmTree fmmtree){
        //System.out.println("created new compuatoin thread");
        this.fmmTree=fmmtree;
    }
    
    public void setFmmTree(FmmTree fmmTree){
        this.fmmTree = fmmTree;
    }
    
    public void genU(){
        u = new double[fmmTree.getX().length];
        for (int i=0; i<u.length; i++) {
            u[i] = Math.random();
        }
    }
    public void run() {
        //System.out.println("computation thread started");
        double runningError = 0;
        //FmmTree tree = animt.getAnim().getTree();
        if (u==null){
            genU();
        }
        double[] indirect=fmmTree.solve(u);
        double[] direct=fmmTree.solveDirect(u);
        this.setError(edu.umiacs.fmm.Util.getError(indirect,direct));
        this.setOpsIndirect(fmmTree.getNumOpsIndirect());
        this.setOpsDirect(fmmTree.getNumOpsDirect());
        //System.out.println("Error: "+error);
        
    }
    
    /**
     * Adds a PropertyChangeListener to the listener list.
     * @param l The listener to add.
     */
    public void addPropertyChangeListener(java.beans.PropertyChangeListener l) {
        
        propertyChangeSupport.addPropertyChangeListener(l);
    }
    
    /**
     * Removes a PropertyChangeListener from the listener list.
     * @param l The listener to remove.
     */
    public void removePropertyChangeListener(java.beans.PropertyChangeListener l) {
        
        propertyChangeSupport.removePropertyChangeListener(l);
    }
    
    /**
     * Getter for property error.
     * @return Value of property error.
     */
    public double getError() {
        
        return this.error;
    }
    
    /**
     * Setter for property error.
     * @param error New value of property error.
     */
    public void setError(double error) {
        
        double oldError = this.error;
        this.error = error;
        propertyChangeSupport.firePropertyChange("error", new Double(oldError), new Double(error));
    }
    
    /**
     * Getter for property opsDirect.
     * @return Value of property opsDirect.
     */
    public long getOpsDirect() {
        
        return this.opsDirect;
    }
    
    /**
     * Setter for property opsDirect.
     * @param opsDirect New value of property opsDirect.
     */
    public void setOpsDirect(long opsDirect) {
        
        long oldOpsDirect = this.opsDirect;
        this.opsDirect = opsDirect;
        propertyChangeSupport.firePropertyChange("opsDirect", new Long(oldOpsDirect), new Long(opsDirect));
    }
    
    /**
     * Getter for property opsIndirect.
     * @return Value of property opsIndirect.
     */
    public long getOpsIndirect() {
        
        return this.opsIndirect;
    }
    
    /**
     * Setter for property opsIndirect.
     * @param opsIndirect New value of property opsIndirect.
     */
    public void setOpsIndirect(long opsIndirect) {
        
        long oldOpsIndirect = this.opsIndirect;
        this.opsIndirect = opsIndirect;
        propertyChangeSupport.firePropertyChange("opsIndirect", new Long(oldOpsIndirect), new Long(opsIndirect));
    }
    
    /**
     * Getter for property u.
     * @return Value of property u.
     */
    public double[] getU() {
        
        return this.u;
    }
    
    /**
     * Setter for property u.
     * @param u New value of property u.
     */
    public void setU(double[] u) {
        
        this.u = u;
    }
    
    
    
}
